package org.apache.turbine.samples.screens;

/*
 * Copyright (c) 1997-2000 The Java Apache Project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the Java Apache
 *    Project for use in the Apache JServ servlet engine project
 *    <http://java.apache.org/>."
 *
 * 4. The names "Apache JServ", "Apache JServ Servlet Engine", "Turbine",
 *    "Apache Turbine", "Turbine Project", "Apache Turbine Project" and
 *    "Java Apache Project" must not be used to endorse or promote products
 *    derived from this software without prior written permission.
 *
 * 5. Products derived from this software may not be called "Apache JServ"
 *    nor may "Apache" nor "Apache JServ" appear in their names without
 *    prior written permission of the Java Apache Project.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the Java Apache
 *    Project for use in the Apache JServ servlet engine project
 *    <http://java.apache.org/>."
 *
 * THIS SOFTWARE IS PROVIDED BY THE JAVA APACHE PROJECT "AS IS" AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE JAVA APACHE PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Java Apache Group. For more information
 * on the Java Apache Project and the Apache JServ Servlet Engine project,
 * please see <http://java.apache.org/>.
 *
 */

// JDK Imports
import java.io.*;
import java.util.*;
import java.net.URL;

// Turbine Imports
import org.apache.turbine.modules.*;
import org.apache.turbine.modules.screens.*;
import org.apache.turbine.util.*;
import org.apache.turbine.services.*;
import org.apache.turbine.services.xmlrpc.*;

// WebMacro Stuff
import org.webmacro.servlet.*;
import org.apache.turbine.util.webmacro.*;

/**
 * Sample Screen for using the XmlRpcService.
 *
 * @author <a href="mailto:josh@stonecottage.com">Josh Lucas</a>
 * @version $Id: Testxmlrpc.java,v 1.3 2000/08/29 20:45:46 gonzalo Exp $
 */
public class Testxmlrpc
    extends WebMacroSiteScreen
{
    /**
     * This is an example of all you need to do to add custom screens
     * into the WebMacro site.  Just extend the WebMacroSiteScreen and
     * override this method.  Note: context is a protected variable in
     * the base class.  It is very important that you add any
     * information to the WebContext using "context"; otherwise it
     * will not show up in your template.
     *
     * @param data Turbine information.
     * @param context Context for web pages.
     */
    public void doBuildTemplate( RunData data,
                                 WebContext context )
    {
        // Could add Security checks here if desired and perform any
        // needed logic.  Then add to the context and let the
        // WebMacroSiteScreen handle the rest.
        String name = null;
        try
        {

            XmlRpcService xs =
            (XmlRpcService)TurbineServices.getInstance().getService(XmlRpcService.SERVICE_NAME);
            if (xs == null)
            {
                org.apache.turbine.util.Log.error("The " + XmlRpcService.SERVICE_NAME + " returned null");
            }
            Vector vec = new Vector();
            vec.addElement(new Integer(41));
            name = (String)xs.executeRpc(new URL("http://betty.userland.com:80/RPC2"),"examples.getStateName",vec);
            if (name == null)
            {
                org.apache.turbine.util.Log.error("The value of name returned null");
            }
            context = getContext(data);
            context.put("stateName",name);
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }
}
