package org.apache.turbine.services.schedule;

/*
 * Copyright (c) 1997-2000 The Java Apache Project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the Java Apache
 *    Project for use in the Apache JServ servlet engine project
 *    <http://java.apache.org/>."
 *
 * 4. The names "Apache JServ", "Apache JServ Servlet Engine", "Turbine",
 *    "Apache Turbine", "Turbine Project", "Apache Turbine Project" and
 *    "Java Apache Project" must not be used to endorse or promote products
 *    derived from this software without prior written permission.
 *
 * 5. Products derived from this software may not be called "Apache JServ"
 *    nor may "Apache" nor "Apache JServ" appear in their names without
 *    prior written permission of the Java Apache Project.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the Java Apache
 *    Project for use in the Apache JServ servlet engine project
 *    <http://java.apache.org/>."
 *
 * THIS SOFTWARE IS PROVIDED BY THE JAVA APACHE PROJECT "AS IS" AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE JAVA APACHE PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Java Apache Group. For more information
 * on the Java Apache Project and the Apache JServ Servlet Engine project,
 * please see <http://java.apache.org/>.
 *
 */

// Java Core Classes
import java.io.*;
import java.util.Date;
import java.util.Vector;

// Turbine Utility Classes
import org.apache.turbine.util.*;

// Turbine loaders
import org.apache.turbine.modules.*;

/**
 * Wrapper for a JobEntry.  This is the that runs the job.
 *
 * @author <a href="mailto:mbryson@mont.mindspring.com">Dave Bryson</a>
 * @version $Id: WorkerThread.java,v 1.3 2000/08/31 18:26:44 gonzalo Exp $
 */
public class WorkerThread
    implements Runnable
{
    /** The job entry. */
    private JobEntry je = null;

    /**
     * Constructor.
     *
     * @param je A JobEntry.
     */
    public WorkerThread(JobEntry je)
    {
        this.je = je;
    }

    /**
     * Run the job.
     */
    public void run()
    {
        if ( je == null )
            return;

        try
        {
            // Run the job.  You can uncomment the log statements for
            // testing.

            // org.apache.turbine.util.Log.note("Scheduled job " +
            //                                  je.getId() + " : " +
            //                                  "task: " + je.getTask() +
            //                                  " Started: " +
            //                                  new Date(System.
            //                                           currentTimeMillis())
            //                                      .toString());

            ScheduledJobLoader.getInstance().exec(je,je.getTask());

            // org.apache.turbine.util.Log.note("Scheduled job " +
            //                                  je.getId() + " : " +
            //                                  "task: " + je.getTask() +
            //                                  " Completed: " +
            //                                  new Date(System.
            //                                           currentTimeMillis())
            //                                      .toString());
        }
        catch(Exception e)
        {
            org.apache.turbine.util.Log.error("Error in WorkerThread " +
                                              "for Task: " +
                                              je.getTask() + " : "+ e);
        }
    }
}
